;
(declare (usual-integrations))
;
(defstruct node
   type
   seq
   label
   marked
   inedges
   outedges
   orbit
   input-output?
   snode)
;
(defstruct edge
   type
   ignore-timing?
   innode inpos
   outnode outpos)
;
(defstruct graph
   nodes
   keys
   t-assoc
   maxgroupval
   maxorbits)
;
(defstruct sm
   vars   ; the variables
   state-v ; a vector containing an assoc list of states and the
             places that correspond
;  states ; an assoc list of states and the places that correspond
   nstate-v ; ditto, but for new states this time.
   newstates ; a simple list of states that haven't been handled yet
             ; state-v is set to #t when a state is here.
   body      ; the executable body of the state machine
   )
;
(defstruct vwire
   join
   begwrite
   endwrite
   begread
   invalidt)
;
;   This is our implementation of a set of integers.  We use a chained
;   hash table.  We make sure the average bucket length remains below
;   1.  We grow by a factor of three each time the table gets too full.
;
;   The only operations we support are iset-member?, iset-insert,
;   and a slightly faster combination of the two, iset-insert?.
;
(defstruct hash
   prime
   size
   limit
   table
   keyfunc)
